var path = require('path');

var wrapper = require('@pact-foundation/pact');

var Pact = wrapper.Pact;
var DEFAULT_PORT = 8080;
var DEFAULT_LOG_LEVEL = 'INFO';
var pactDir = path.resolve(process.cwd(), 'contract/documents');
var pactLog = path.resolve(process.cwd(), 'contract/logs', 'pact.log');
var defaults = {
  logLevel: DEFAULT_LOG_LEVEL,
  port: Number(process.env.PACT_SERVER_PORT || DEFAULT_PORT)
}; // used to kill any left over mock server instances

process.on('SIGINT', function () {
  wrapper.removeAllServers();
});

var getProvider = function getProvider(_ref) {
  var consumer = _ref.consumer,
      provider = _ref.provider,
      _ref$logLevel = _ref.logLevel,
      logLevel = _ref$logLevel === void 0 ? defaults.logLevel : _ref$logLevel,
      _ref$port = _ref.port,
      port = _ref$port === void 0 ? defaults.port : _ref$port;
  return new Pact({
    consumer: consumer,
    provider: provider,
    dir: pactDir,
    log: pactLog,
    logLevel: logLevel,
    port: port
  });
};

module.exports = {
  getProvider: getProvider
};